install.packages("alabama")
library("alabama")
library(zoo)


data=read.table("/Users/shujiema/stat/research/papers/Collaboration_w_Hardle/program/Strike and Calls 2011/Strike and Calls 2011/Call and Strikes on16-Nov-2011",header = TRUE, fileEncoding="latin1")

#DaxIndex=read.table("/Users/shujiema/stat/research/papers/Collaboration_w_Hardle/program/DaxIndex.dat",header = TRUE, fileEncoding="latin1")

DaxIndex=read.table("/Users/shujiema/stat/research/papers/Collaboration_w_Hardle/program/dax_index.txt",header = TRUE, fileEncoding="latin1")

ind=seq(1,nrow(data),length=nrow(data))
z=data[,1]; #strike price
y=data[,2]  #call price
m=length(z)

n=500
d1=nrow(DaxIndex)
Dax=DaxIndex[(5485-n+1):5485,]
x=Dax[,2]
n=length(x)

Year <- c("03/12/2009", "29/04/2010", "16/09/2010", "07/02/2011", "29/06/2011", "16/11/2011") 

plot(x, xlab = "", ylab = "", main = "",type="l", col="blue",lwd=4, axes = FALSE)
axis(side = 1, lab=F)
axis(side = 2,cex=1.2,font=2)

text(axTicks(1), par("usr")[3] - 2, srt=45, adj=1,
          labels=Year,
          xpd=T, cex=0.8,font=2)

        
plot(z,y, xlab = "", ylab = "", main = "",col="blue",cex=1.5,font=2)
 
##take logarithm of the data
#x=log(x)
#y=log(y)
#z=log(z)

##detrend of the data
#x=x[2:n]-x[1:(n-1)]

#y=y[2:m]-y[1:(m-1)]
#z=z[2:m]-z[1:(m-1)]

n=length(x)
m=length(y)


pn=density(x,kernel="gaussian")  ##kernel density estimation of x 
h=pn$bw  ##bandwidth
	#z1=z%*%matrix(1,nrow=1,ncol=n)
 	#z2=matrix(1,nrow=m,ncol=1)%*%t(x)
 	#zs=(z1-z2)/h
  	#AK=(zs^2/2-zs^4/12+(2/3)*zs-(1/2-1/12-2/3))*h*(3/4) ##second order integration of Epanechnikov kernel
  	#AK=AK*(zs<=1)*(zs>=-1)+zs*h*(zs>1)
  	AK=matrix(0,nrow=m,ncol=n)
  	for(j in 1:n){
  	for (i in 1:m){
	zi=z[i]
	xj=x[j]
  integrand <- function(x) {1-pnorm((x-xj)/h)}
   ff=integrate(integrand, lower = zi, upper =max(x))
   AK[i,j]=ff[[1]]
}
} 	

lambda=0.5### tuning parameter

omegaini=seq(1/n,1/n,length=n)
omegaini=runif(n, min=0, max=(2/n))
#omegaini=omegaini[1:(n-1)]




omegaold=omegaini	

 fn <- function(x) {
 	w=matrix(1,nrow=m,ncol=1)%*%t(x)
    Aq=rowSums((AK*w))  ##second order integration of q
    Qtilda=mean((y-Aq)^2)-lambda*mean(log(n*x))
    Qtilda
    }
    
        gr <- function(x){
       DEV=t(AK)%*%AK%*%x-t(AK)%*%y-((lambda/n)*(1/x))
       DEV
    }
    heq <- function(x) {
h <- rep(NA, 1)
h[1] <- sum(x) - 1
h

     }
 heq.jac <- function(x) {
j <- matrix(NA, 1, length(x))
j[1, ] <- seq(1,1,length=length(x))
j
}
hin <- function(x) {
h <- x
h
}
hin.jac <- function(x) {
j <- diag(length(x))
j
}


        omegaopt= constrOptim.nl(par=omegaold,fn=fn, gr=gr, heq=heq, heq.jac=heq.jac, hin=hin, hin.jac=hin.jac)
          omeganew=omegaopt$par
          omega=omeganew

x=x/x[length(x)]
fn=density(x,kernel="gaussian")  ##kernel density estimation of x 
h=fn$bw  ##bandwidth
  	K=matrix(0,nrow=n,ncol=n)
  	for(j in 1:n){
  	for (i in 1:n){
	xi=x[i]
	xj=x[j]
   K[i,j]=(1/h)*dnorm((xi-xj)/h)
}
}

 	w=matrix(1,nrow=n,ncol=1)%*%t(omega)
    qn=rowSums(K*w)
 	ww=matrix(1,nrow=m,ncol=1)%*%t(omega)
    Aq=rowSums((AK*ww))  ##second order integration of q

fn =rowSums(K)/n

#ration=qn/fn
#ratio=dp/dq
ration=qn/fn
r=cbind(x,qn,ration,fn)
r=r[order(r[,1]),]


plot(r[,1],r[,4],xlab="", ylab="",main="lambda=0.5",ylim=c(min(c(qn,fn)),max(c(qn,fn))),xlim=c(min(x),max(x)), type = "l",lwd=5, col="red",cex=2,font=2)

lines(r[,1],r[,2],lty=2,lwd=5, col="blue")

lines(r[,1],r[,3],lwd=2, col="black")

lines(r[,1],r[,7],lty=2,lwd=3, col="magenta")

plot(r[,1],r[,3],xlab="", ylab="",main="lambda=0.5", type = "l",lwd=5, col="black")

r=cbind(z,Aq-200,y)
r=r[order(r[,1]),]
plot(r[,1],r[,2],xlab="", ylab="",main="lambda=0.5",type = "l",lwd=4, col="red",cex=2,font=2)
points(r[,1],r[,3],col="blue")
